Halide 22.0.0 Halide compiler and libraries

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Halide::Internal::GeneratorInputBase Class Referenceabstract

`#include <Generator.h>`

Inheritance diagram for Halide::Internal::GeneratorInputBase:

## Public Member Functions
| ~GeneratorInputBase () override
Public Member Functions inherited from Halide::Internal::GIOBase
virtual | ~GIOBase ()=default
void | set_type (const Type &type)
void | set_dimensions (int dims)
void | set_array_size (int size)
| GIOBase (const GIOBase &)=delete
GIOBase & | operator= (const GIOBase &)=delete
| GIOBase (GIOBase &&)=delete
GIOBase & | operator= (GIOBase &&)=delete

## Protected Member Functions
| GeneratorInputBase (size_t array_size, const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
| GeneratorInputBase (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
Parameter | parameter () const
void | init_internals ()
void | set_inputs (const std::vector< StubInput > &inputs)
virtual void | set_def_min_max ()
void | verify_internals () override
virtual std::string | get_c_type () const =0
void | check_value_writable () const override
const char * | input_or_output () const override
void | set_estimate_impl (const Var &var, const Expr &min, const Expr &extent)
void | set_estimates_impl (const Region &estimates)
Protected Member Functions inherited from Halide::Internal::GIOBase
bool | array_size_defined () const
size_t | array_size () const
virtual bool | is_array () const
const std::string & | name () const
ArgInfoKind | kind () const
bool | gio_types_defined () const
const std::vector< Type > & | gio_types () const
Type | gio_type () const
bool | dims_defined () const
int | dims () const
const std::vector< Func > & | funcs () const
const std::vector< Expr > & | exprs () const
| GIOBase (size_t array_size, const std::string &name, ArgInfoKind kind, const std::vector< Type > &types, int dims)
std::string | array_name (size_t i) const
virtual void | verify_internals ()
void | check_matching_array_size (size_t size) const
void | check_matching_types (const std::vector< Type > &t) const
void | check_matching_dims (int d) const
template<typename ElemType >
const std::vector< ElemType > & | get_values () const
void | check_gio_access () const
virtual void | check_value_writable () const =0
virtual const char * | input_or_output () const =0
template<>
const std::vector< Expr > & | get_values () const
template<>
const std::vector< Func > & | get_values () const

## Protected Attributes
std::vector< Parameter > | parameters_
bool | inputs_set = false
Protected Attributes inherited from Halide::Internal::GIOBase
int | array_size_
const std::string | name_
const ArgInfoKind | kind_
std::vector< Type > | types_
int | dims_
std::vector< Func > | funcs_
std::vector< Expr > | exprs_
GeneratorBase * | generator {nullptr}

## Detailed Description

Definition at line 1539 of file Generator.h.

## Constructor & Destructor Documentation

## ◆ GeneratorInputBase() [1/2]

Halide::Internal::GeneratorInputBase::GeneratorInputBase | ( | size_t | array_size,
|  | const std::string & | name,
|  | ArgInfoKind | kind,
|  | const std::vector< Type > & | t,
|  | int | d
| ) |  |
| protected

## ◆ GeneratorInputBase() [2/2]

Halide::Internal::GeneratorInputBase::GeneratorInputBase | ( | const std::string & | name,
|  | ArgInfoKind | kind,
|  | const std::vector< Type > & | t,
|  | int | d
| ) |  |
| protected

## ◆ ~GeneratorInputBase()

Halide::Internal::GeneratorInputBase::~GeneratorInputBase | ( |  | ) |
| override

## Member Function Documentation

## ◆ parameter()

Parameter Halide::Internal::GeneratorInputBase::parameter | ( |  | ) | const
| protected

## ◆ init_internals()

void Halide::Internal::GeneratorInputBase::init_internals | ( |  | ) |
| protected

## ◆ set_inputs()

void Halide::Internal::GeneratorInputBase::set_inputs | ( | const std::vector< StubInput > & | inputs | ) |
| protected

## ◆ set_def_min_max()

virtual void Halide::Internal::GeneratorInputBase::set_def_min_max | ( |  | ) |
| protected virtual

Reimplemented in Halide::Internal::GeneratorInput_Scalar< T >, and Halide::Internal::GeneratorInput_Arithmetic< T >.

## ◆ verify_internals()

void Halide::Internal::GeneratorInputBase::verify_internals | ( |  | ) |
| override protected virtual

Reimplemented from Halide::Internal::GIOBase.

## ◆ get_c_type()

virtual std::string Halide::Internal::GeneratorInputBase::get_c_type | ( |  | ) | const
| protected pure virtual

Implemented in Halide::Internal::GeneratorInput_Buffer< T >, Halide::Internal::GeneratorInput_Func< T >, Halide::Internal::GeneratorInput_DynamicScalar< T >, and Halide::Internal::GeneratorInput_Scalar< T >.

## ◆ check_value_writable()

void Halide::Internal::GeneratorInputBase::check_value_writable | ( |  | ) | const
| override protected virtual

Implements Halide::Internal::GIOBase.

## ◆ input_or_output()

const char * Halide::Internal::GeneratorInputBase::input_or_output | ( |  | ) | const
| inline override protected virtual

Implements Halide::Internal::GIOBase.

Definition at line 1570 of file Generator.h.

## ◆ set_estimate_impl()

void Halide::Internal::GeneratorInputBase::set_estimate_impl | ( | const Var & | var,
|  | const Expr & | min,
|  | const Expr & | extent
| ) |  |
| protected

Referenced by Halide::Internal::GeneratorInput_Buffer< T >::set_estimate(), and Halide::Internal::GeneratorInput_Func< T >::set_estimate().

## ◆ set_estimates_impl()

void Halide::Internal::GeneratorInputBase::set_estimates_impl | ( | const Region & | estimates | ) |
| protected

Referenced by Halide::Internal::GeneratorInput_Buffer< T >::set_estimates(), and Halide::Internal::GeneratorInput_Func< T >::set_estimates().

## Member Data Documentation

## ◆ parameters_

std::vector<Parameter> Halide::Internal::GeneratorInputBase::parameters_
| protected

Definition at line 1552 of file Generator.h.

Referenced by Halide::Internal::GeneratorInput_Buffer< T >::at(), Halide::Internal::GeneratorInput_Buffer< T >::operator ExternFuncArgument(), Halide::Internal::GeneratorInput_Func< T >::operator ExternFuncArgument(), Halide::Internal::GeneratorInput_Buffer< T >::operator ImageParam(), Halide::Internal::GeneratorInput_Buffer< T >::operator StubInputBuffer< T2 >(), Halide::Internal::GeneratorInput_Buffer< T >::operator[](), Halide::Internal::GeneratorInput_Scalar< T >::set_def_min_max(), Halide::Internal::GeneratorInput_Arithmetic< T >::set_def_min_max(), Halide::Internal::GeneratorInput_DynamicScalar< T >::set_estimate(), Halide::Internal::GeneratorInput_Scalar< T >::set_estimate(), and Halide::Internal::GeneratorInput_Buffer< T >::size().

## ◆ inputs_set

bool Halide::Internal::GeneratorInputBase::inputs_set = false
| protected

Definition at line 1558 of file Generator.h.

The documentation for this class was generated from the following file:

- src/Generator.h